"use strict";

require("core-js/modules/es6.symbol.js");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ButtonUnReadChat = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("core-js/modules/web.dom.iterable.js");

var _icons = require("@ant-design/icons");

var _antd = require("antd");

var _graphqlChat = require("../Graphql/graphqlChat");

var _react = _interopRequireWildcard(require("react"));

var _pusherCodeby = require("../../../configs/pusherCodeby");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const ButtonUnReadChat = _ref => {
  var _chat$data;

  let {
    app_id,
    people,
    unique,
    onClick: _onClick,
    children
  } = _ref;
  const [chat, setChat] = (0, _react.useState)({
    isRefresh: true
  });
  const roomId = "".concat(app_id, "-").concat(unique.special_id);
  (0, _react.useEffect)(() => {
    const listener = _pusherCodeby.pusherCodeby.room(roomId).onAny((event, data) => {
      console.log('event, data', {
        event,
        data
      });

      switch (event) {
        case 'chat':
        case 'fresh_detail_chat':
          setChat(_objectSpread(_objectSpread({}, chat), {}, {
            isRefresh: true
          }));
          break;
      }
    });

    return () => _pusherCodeby.pusherCodeby.offAny(listener);
  });
  (0, _react.useEffect)(() => {
    if (!(chat.isRefresh && !chat.isLoading)) return;
    setChat(_objectSpread(_objectSpread({}, chat), {}, {
      isLoading: true
    }));

    (async () => {
      const res = await (0, _graphqlChat.detailChat)({
        app_id,
        people,
        unique
      });
      setChat({
        data: res.data.detail_chat
      });
    })();
  }, [chat]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_antd.Badge, {
    count: chat === null || chat === void 0 ? void 0 : (_chat$data = chat.data) === null || _chat$data === void 0 ? void 0 : _chat$data.count_read_comment
  }, children && /*#__PURE__*/_react.default.createElement("span", {
    onClick: e => {
      if (_onClick) _onClick(e);
    }
  }, children), !children && /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.MessageOutlined, null),
    loading: chat.isLoading,
    onClick: e => {
      if (_onClick) _onClick(e);
    }
  })));
};

exports.ButtonUnReadChat = ButtonUnReadChat;