"use strict";

require("core-js/modules/es6.symbol.js");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("core-js/modules/web.dom.iterable.js");

var _antd = require("antd");

var _react = _interopRequireWildcard(require("react"));

var _graphqlSubComment = require("../Graphql/graphqlSubComment");

var _graphqlComment = require("../Graphql/graphqlComment");

var _icons = require("@ant-design/icons");

var _pusherCodeby = require("../../../configs/pusherCodeby");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const InputComment = props => {
  const {
    onChange,
    iData,
    onClose,
    unique,
    app_id,
    people,
    other
  } = props;

  const [form] = _antd.Form.useForm();

  const [iComment, setIComment] = (0, _react.useState)({});
  const roomId = "".concat(app_id, "-").concat(unique.special_id);
  (0, _react.useEffect)(() => {
    form.setFieldsValue({
      type: "string"
    });
    form.setFieldsValue(props);
  }, [props]);
  (0, _react.useEffect)(() => {
    form.setFieldsValue(iData);
  }, [iData]);
  (0, _react.useEffect)(() => {
    if (iComment.data && onChange) {
      onChange(iComment);
      console.log('InputComment iComment', iComment);
      console.log('unique', {
        unique,
        people,
        other
      });

      _pusherCodeby.pusherCodeby.room(roomId).cast('chat', iComment);

      const roomListId = "".concat(app_id, "-").concat(other.special_id);

      _pusherCodeby.pusherCodeby.room(roomListId).cast('list', _objectSpread(_objectSpread({}, iComment), {}, {
        unique,
        people,
        other
      }));
    }
  }, [iComment]);

  const submitComment = async values => {
    var _res$data;

    setIComment({
      isLoading: true
    });

    if (values.comment_id) {
      const res = await (0, _graphqlSubComment.upsertSubComment)(values);
      setIComment({
        data: res.data.upsert_subComment
      });
      return;
    }

    const res = await (0, _graphqlComment.upsertComment)(values);
    setIComment({
      data: res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : _res$data.upsert_comment
    });
  };

  return /*#__PURE__*/_react.default.createElement("section", {
    className: ""
  }, /*#__PURE__*/_react.default.createElement(_antd.Form, {
    className: "relative -mb-6",
    form: form,
    onFinish: async values => {
      submitComment(values);
      form.setFieldsValue({
        content: null
      });
    }
  }, /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    rules: [{
      required: true
    }],
    name: "content"
  }, /*#__PURE__*/_react.default.createElement(_antd.Input.TextArea, {
    className: "w-full",
    placeholder: "Aa",
    onKeyDown: e => {
      if (e.key === 'Enter') {
        form.submit();
        e.preventDefault();
      }
    },
    autoSize: {
      minRows: 3,
      maxRows: 4
    }
  })), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    hidden: true,
    name: "id"
  }), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    hidden: true,
    name: "app_id"
  }), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    hidden: true,
    name: "unique"
  }), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    hidden: true,
    name: "comment_id"
  }), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    hidden: true,
    name: "people"
  }), /*#__PURE__*/_react.default.createElement(_antd.Form.Item, {
    hidden: true,
    name: "type"
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "absolute top-0 right-0 mr-2 mt-1 z-10"
  }, iData && /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.CloseOutlined, null),
    type: "link",
    className: "absolute top-0 right-0 -mt-10 -mr-2",
    onClick: () => onClose()
  }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    type: "link",
    icon: /*#__PURE__*/_react.default.createElement(_icons.SmileOutlined, null)
  }), /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    type: "primary",
    htmlType: "submit",
    icon: /*#__PURE__*/_react.default.createElement(_icons.SendOutlined, null),
    loading: iComment.isLoading
  }))));
};

var _default = InputComment;
exports.default = _default;