"use strict";

require("core-js/modules/es6.symbol.js");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ListChatRoom = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("core-js/modules/web.dom.iterable.js");

var _antd = require("antd");

var _react = _interopRequireWildcard(require("react"));

var _graphqlChatRoom = require("../Graphql/graphqlChatRoom");

var _pusherCodeby = require("../../../configs/pusherCodeby");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const ListChatRoom = _ref => {
  let {
    app_id,
    people,
    onClick: _onClick,
    others = []
  } = _ref;
  const [chatRooms, setChatRooms] = (0, _react.useState)({
    isRefresh: true
  });
  (0, _react.useEffect)(() => {
    if (!(chatRooms.isRefresh && !chatRooms.isLoading)) return;
    setChatRooms(_objectSpread(_objectSpread({}, chatRooms), {}, {
      isLoading: true
    }));

    (async () => {
      const res = await (0, _graphqlChatRoom.listChatRoom)({
        app_id,
        people
      });
      setChatRooms({
        data: res.data.list_chat_room
      });
    })();
  }, [chatRooms]);
  (0, _react.useEffect)(() => {
    const roomListId = "".concat(app_id, "-").concat(people.special_id);

    const listener = _pusherCodeby.pusherCodeby.room(roomListId).onAny((event, data) => {
      console.log('ListChatRoom event', {
        event,
        data
      });

      (async () => {
        const res = await (0, _graphqlChatRoom.listChatRoom)({
          app_id,
          people
        });
        setChatRooms({
          data: res.data.list_chat_room
        });
      })(); // switch (event) {
      //     case 'chat':
      //         setLChatRT([data.data, ...lChatRT])
      //         break;
      //     case 'video_chat_cancel':
      //         if (data.people.special_id != people.special_id)
      //             setVideoChat(null);
      //         break;
      //     case 'video_chat':
      //         if (data.people.special_id != people.special_id)
      //             setVideoChat(data);
      //         break;
      // }

    });

    return () => _pusherCodeby.pusherCodeby.offAny(listener);
  });
  const [roomList, setRoomList] = (0, _react.useState)([]);
  (0, _react.useEffect)(() => {
    var _chatRooms$data;

    console.log('chatRooms', chatRooms);
    const arr = (others !== null && others !== void 0 ? others : []).concat((_chatRooms$data = chatRooms === null || chatRooms === void 0 ? void 0 : chatRooms.data) !== null && _chatRooms$data !== void 0 ? _chatRooms$data : []);
    const roomList = [...new Map(arr.map(v => [v.unique.special_id, v])).values()];
    setRoomList(roomList);
  }, [chatRooms, others]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: ""
  }, /*#__PURE__*/_react.default.createElement(_antd.List, {
    loading: chatRooms.isLoading,
    dataSource: roomList,
    renderItem: item => {
      var _item$other, _item$other2, _item$other3, _item$comment_last;

      return /*#__PURE__*/_react.default.createElement(_antd.List.Item, {
        className: "relative hover:bg-gray-200 px-2 cursor-pointer",
        onClick: () => {
          if (_onClick) _onClick({
            people: item.other,
            unique: item.unique
          });
        }
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "w-4 absolute absolute-y right-0 mr-3"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "pb-1x1 relative rounded-full overflow-hidden bg-gray-300"
      }, /*#__PURE__*/_react.default.createElement("img", {
        alt: "",
        src: item === null || item === void 0 ? void 0 : (_item$other = item.other) === null || _item$other === void 0 ? void 0 : _item$other.avatar,
        className: "absolute h-full w-full object-cover"
      }))), /*#__PURE__*/_react.default.createElement("div", {
        className: "flex items-center relative block"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "w-14 relative"
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "z-10 absolute bottom-0 right-0 mr-0 h-4 w-4 block bg-red-500 rounded-full border-2 border-white"
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: "pb-1x1 relative rounded-full overflow-hidden bg-gray-300"
      }, /*#__PURE__*/_react.default.createElement("img", {
        alt: "",
        src: item === null || item === void 0 ? void 0 : (_item$other2 = item.other) === null || _item$other2 === void 0 ? void 0 : _item$other2.avatar,
        className: "absolute h-full w-full object-cover"
      }))), /*#__PURE__*/_react.default.createElement("figcaption", {
        className: "ml-2"
      }, /*#__PURE__*/_react.default.createElement("p", null, item === null || item === void 0 ? void 0 : (_item$other3 = item.other) === null || _item$other3 === void 0 ? void 0 : _item$other3.name), /*#__PURE__*/_react.default.createElement("p", {
        className: "text-gray-500"
      }, item === null || item === void 0 ? void 0 : (_item$comment_last = item.comment_last) === null || _item$comment_last === void 0 ? void 0 : _item$comment_last.content))));
    }
  }));
};

exports.ListChatRoom = ListChatRoom;