"use strict";

require("core-js/modules/web.dom.iterable.js");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ListChatRoomSearch = void 0;

var _antd = require("antd");

var _react = _interopRequireWildcard(require("react"));

var _graphqlChatRoom = require("../Graphql/graphqlChatRoom");

var _icons = require("@ant-design/icons");

var _ListChatRoom = require("./ListChatRoom");

var _debounce = _interopRequireDefault(require("lodash/debounce"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const ListChatRoomSearch = _ref => {
  let {
    app_id,
    people,
    onClick,
    onClose,
    onSearch,
    others = []
  } = _ref;
  const debounceChange = (0, _debounce.default)(value => {
    onSearch(value);
  }, 500);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: ""
  }, /*#__PURE__*/_react.default.createElement("section", {
    className: "rounded-sm shadow-xl border-t border-l border-r"
  }, /*#__PURE__*/_react.default.createElement("header", {
    className: "relative"
  }, /*#__PURE__*/_react.default.createElement(_antd.Input, {
    size: "large",
    placeholder: "Search",
    prefix: /*#__PURE__*/_react.default.createElement(_icons.SearchOutlined, null),
    className: "border-l-0 border-t-0 border-r-0",
    onChange: e => debounceChange(e.target.value)
  }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.CloseOutlined, null),
    className: "absolute right-0 z-10 border-none m-1",
    onClick: e => onClose(e)
  })), /*#__PURE__*/_react.default.createElement("main", {
    className: "w-96 max-h-96 overflow-auto"
  }, /*#__PURE__*/_react.default.createElement(_ListChatRoom.ListChatRoom, {
    onClick: onClick,
    app_id: app_id,
    people: people,
    others: others
  }))));
};

exports.ListChatRoomSearch = ListChatRoomSearch;