"use strict";

require("core-js/modules/es6.symbol.js");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("core-js/modules/web.dom.iterable.js");

var _react = _interopRequireWildcard(require("react"));

var _graphqlSubComment = require("../Graphql/graphqlSubComment");

var _ItemComment = _interopRequireDefault(require("./ItemComment"));

var _antd = require("antd");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const ParentComment = props => {
  var _lsComment$data;

  const {
    cData,
    onChange: _onChange
  } = props;
  const [showReply, setShowReply] = (0, _react.useState)(false);
  const [lsComment, setLSComment] = (0, _react.useState)({
    data: [],
    pageInfo: {}
  });
  const [totalSubs, setTotalSubs] = (0, _react.useState)(0);

  const getLSComment = async () => {
    setLSComment(_objectSpread(_objectSpread({}, lsComment), {}, {
      isLoading: true
    }));
    const res = await (0, _graphqlSubComment.listSubComment)({
      comment_id: cData.id
    });
    setLSComment(res.data.list_subComment);
  };

  (0, _react.useEffect)(() => {
    if (showReply) (async () => getLSComment())();
  }, [showReply]);
  (0, _react.useEffect)(() => {
    const totalSubs = lsComment.data ? lsComment.data.length : cData.total_subs;
    setTotalSubs(totalSubs); // console.log('lsComment', lsComment)
  }, [lsComment, cData]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: ""
  }, /*#__PURE__*/_react.default.createElement(_ItemComment.default, (0, _extends2.default)({}, props, {
    data: cData,
    onChange: values => {
      if (values.act == 'add') {
        setLSComment(_objectSpread(_objectSpread({}, lsComment), {}, {
          data: [values.data, ...lsComment.data],
          pageInfo: _objectSpread(_objectSpread({}, lsComment.pageInfo), {}, {
            total_item: lsComment.pageInfo.total_item + 1
          })
        }));
        return;
      } // console.log('ItemComment values', values)


      _onChange(values); // if (values.act == 'delete')
      //     return;
      // getLSComment();
      // setShowReply(true);

    }
  })), totalSubs != 0 && /*#__PURE__*/_react.default.createElement("div", {
    className: "ml-14"
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "p-0",
    type: "link",
    icon: /*#__PURE__*/_react.default.createElement("i", {
      className: "fas fa-share"
    }),
    onClick: () => setShowReply(!showReply)
  }, /*#__PURE__*/_react.default.createElement("b", {
    className: "ml-2"
  }, totalSubs, " tr\u1EA3 l\u1EDDi"))), showReply && ((_lsComment$data = lsComment === null || lsComment === void 0 ? void 0 : lsComment.data) !== null && _lsComment$data !== void 0 ? _lsComment$data : []).length != 0 && /*#__PURE__*/_react.default.createElement("div", {
    className: "ml-12 pl-2 border-l "
  }, /*#__PURE__*/_react.default.createElement(_antd.List, {
    loading: lsComment.isLoading,
    itemLayout: "vertical",
    dataSource: lsComment.data,
    renderItem: item => /*#__PURE__*/_react.default.createElement(_antd.List.Item, {
      key: item.id
    }, /*#__PURE__*/_react.default.createElement(_ItemComment.default, (0, _extends2.default)({}, props, {
      isSub: true,
      data: item,
      onChange: values => {
        if (values.act == 'delete') {
          var _lsComment$data2;

          const dlsComment = ((_lsComment$data2 = lsComment === null || lsComment === void 0 ? void 0 : lsComment.data) !== null && _lsComment$data2 !== void 0 ? _lsComment$data2 : []).filter(item => item.id != values.data.id);

          const nlsComment = _objectSpread(_objectSpread({}, lsComment), {}, {
            data: dlsComment,
            pageInfo: _objectSpread(_objectSpread({}, lsComment.pageInfo), {}, {
              total_item: lsComment.pageInfo.total_item - 1
            })
          });

          setLSComment(nlsComment);
          return;
        }
      }
    })))
  })));
};

var _default = ParentComment;
exports.default = _default;