"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.upsertChat = exports.detailChat = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _graphqlClient = require("./graphqlClient");

var _templateObject, _templateObject2;

const detailChat = async variables => {
  const query = (0, _graphqlTag.default)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n        query($app_id: ID!, $people: JSON!, $unique: JSON!){\n    detail_chat(\n        app_id: $app_id\n        people: $people\n        unique: $unique\n    ) {\n        count_read_comment\n    }\n}"])));
  return await _graphqlClient.graphqlClient.query({
    query,
    variables
  });
};
/*
const listChat = async (variables) => {
    const query = gql`
        query($app_id: ID!, $people: JSON!){
    list_chat(app_id: $app_id, people: $people) {
        id
        content
        people{
            id
            name
            avatar
        }
        created_at
        count_read_comment
    }
}`;
    return await graphqlClient.query({
        query,
        variables,
    });
}
*/


exports.detailChat = detailChat;

const upsertChat = async variables => {
  const mutationAPI = () => {
    const mutation = (0, _graphqlTag.default)(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n        mutation($id: ID, $app_id: ID!, $read_comment_id: Int, $people: JSON!, $unique: JSON!) {\n  upsert_chat(\n    input: {\n      id: $id,\n      app_id: $app_id,\n      read_comment_id: $read_comment_id,\n      people: $people,\n      unique: $unique\n    }\n  ) {\n    id\n  }\n}\n"])));
    return _graphqlClient.graphqlClient.mutate({
      mutation,
      variables
    });
  };

  try {
    return await mutationAPI().then(res => {
      return res;
    });
  } catch (e) {// console.log('e', e)
  }
};

exports.upsertChat = upsertChat;