"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.upsertChatRoom = exports.listChatRoom = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _graphqlClient = require("./graphqlClient");

var _templateObject, _templateObject2;

const upsertChatRoom = async variables => {
  const mutationAPI = () => {
    const mutation = (0, _graphqlTag.default)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n        mutation($id: ID, $app_id: ID!, $people_list: [JSON]!, $unique: JSON!) {\n  upsert_chat_room(\n    input: {\n      id: $id,\n      app_id: $app_id,\n      people_list: $people_list,\n      unique: $unique\n    }\n  ) {\n    id\n  }\n}\n"])));
    return _graphqlClient.graphqlClient.mutate({
      mutation,
      variables
    });
  };

  try {
    return await mutationAPI().then(res => {
      return res;
    });
  } catch (e) {// console.log('e', e)
  }
};

exports.upsertChatRoom = upsertChatRoom;

const listChatRoom = async variables => {
  const query = (0, _graphqlTag.default)(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n        query($app_id: ID!, $people: JSON!){\n    list_chat_room(app_id: $app_id, people: $people) {\n        id\n        people_list{\n            id\n            special_id\n            name\n            avatar\n        }\n        other_list{\n            id\n            special_id\n            name\n            avatar\n        }\n        other{\n            id\n            special_id\n            name\n            avatar\n        }\n        comment_last{\n            content\n        }\n        unique{\n            id\n            special_id\n        }\n    }\n}"])));
  return await _graphqlClient.graphqlClient.query({
    query,
    variables
  });
};

exports.listChatRoom = listChatRoom;