"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.graphqlClient = void 0;

var _universalCookie = _interopRequireDefault(require("universal-cookie"));

var _apolloClient = require("apollo-client");

var _apolloLink = require("apollo-link");

var _apolloLinkHttp = require("apollo-link-http");

var _apolloLinkError = require("apollo-link-error");

var _apolloCacheInmemory = require("apollo-cache-inmemory");

var _antd = require("antd");

var _cookies$get;

const cookies = new _universalCookie.default();
const httpLink = new _apolloLinkHttp.HttpLink({
  uri: "".concat(process.env.REACT_APP_COMMENT_CODEBY, "/graphql"),
  headers: {
    Authorization: "Bearer ".concat((_cookies$get = cookies.get("ppe-token")) !== null && _cookies$get !== void 0 ? _cookies$get : "")
  }
});
const errorLink = (0, _apolloLinkError.onError)(_ref => {
  let {
    graphQLErrors,
    networkError
  } = _ref;

  if (graphQLErrors) {
    graphQLErrors.map(_ref2 => {
      let {
        message,
        locations,
        path
      } = _ref2;
      console.log("[GraphQL error]: Message: ".concat(message, ", Location: ").concat(locations, ", Path: ").concat(path)); // if (path === `login`) {
      //   return error(`Email or password are wrongs!`);
      // }
      //
      // if (message === "Unauthenticated.") {
      //   return window.location.assign("/m/LoginPage");
      // }

      _antd.notification.info({
        message
      });
    });
  }

  if (networkError) {
    console.log("[Network error]: ".concat(networkError));
  }
});
const defaultOptions = {
  watchQuery: {
    fetchPolicy: "no-cache",
    errorPolicy: "ignore"
  },
  query: {
    fetchPolicy: "no-cache",
    errorPolicy: "all"
  }
};
const graphqlClient = new _apolloClient.ApolloClient({
  link: _apolloLink.ApolloLink.from([errorLink, httpLink]),
  cache: new _apolloCacheInmemory.InMemoryCache(),
  defaultOptions
});
exports.graphqlClient = graphqlClient;