"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.upsertComment = exports.listComment = exports.deleteComment = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _graphqlClient = require("./graphqlClient");

var _templateObject, _templateObject2, _templateObject3;

const listComment = async variables => {
  const query = (0, _graphqlTag.default)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n        query($app_id: ID!, $unique:JSON!, $name: String, $args: JSON){\n    list_comment(\n        app_id: $app_id\n        unique: $unique\n        name: $name\n        args: $args\n    ) {\n        data{\n            id\n            type\n            content\n            people{id, special_id, name, avatar}\n            total_subs\n            created_at\n            total_like\n        }\n        pageInfo\n    }\n}"])));
  return await _graphqlClient.graphqlClient.query({
    query,
    variables
  });
};

exports.listComment = listComment;

const upsertComment = async variables => {
  const mutationAPI = () => {
    const mutation = (0, _graphqlTag.default)(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n        mutation($id: ID, $app_id: ID!, $type: String!, $content: String!, $people:JSON!, $unique: JSON!) {\n  upsert_comment(\n    input: {\n      id: $id,\n      app_id: $app_id,\n      unique: $unique,\n      type: $type,\n      content: $content,\n      people: $people\n    }\n  ) {\n    id\n    type\n    content\n    created_at\n    updated_at\n    people{id,special_id,name,avatar,profile_url}\n    subComment{id}\n    total_like\n    total_subs\n  }\n}\n"])));
    return _graphqlClient.graphqlClient.mutate({
      mutation,
      variables
    });
  };

  try {
    return await mutationAPI().then(res => {
      return res;
    });
  } catch (e) {// console.log('e', e)
  }
};

exports.upsertComment = upsertComment;

const deleteComment = async variables => {
  const mutationAPI = () => {
    const mutation = (0, _graphqlTag.default)(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n        mutation($id: ID, $ids: [ID]) {\n  delete_comment(\n    input: {\n      id: $id,\n      ids: $ids,\n    }\n  )\n}"])));
    return _graphqlClient.graphqlClient.mutate({
      mutation,
      variables
    });
  };

  try {
    return await mutationAPI().then(res => {
      return res;
    });
  } catch (e) {// console.log('e', e)
  }
};

exports.deleteComment = deleteComment;