"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.upsertUnique = exports.listUnique = exports.deleteUnique = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _graphqlClient = require("./graphqlClient");

var _templateObject, _templateObject2, _templateObject3;

const listUnique = async variables => {
  const query = (0, _graphqlTag.default)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n        query($comment_id: ID!, $name: String, $args: JSON){\n    list_unique(\n        comment_id: $comment_id\n        name: $name\n        args: $args\n    ) {\n        data{\n            id\n            content\n            created_at\n            people{id, name, avatar}\n            total_like\n            comment{id}\n        }\n        pageInfo\n    }\n}"])));
  return await _graphqlClient.graphqlClient.query({
    query,
    variables
  });
};

exports.listUnique = listUnique;

const upsertUnique = async variables => {
  const mutationAPI = () => {
    const mutation = (0, _graphqlTag.default)(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n        mutation($id: ID, $app_id: ID!, $unique: JSON!) {\n  upsert_unique(\n    input: {\n      id: $id,\n      app_id: $app_id,\n      unique: $unique\n    }\n  ) {\n    id\n    total_like\n    view_count\n  }\n}"])));
    return _graphqlClient.graphqlClient.mutate({
      mutation,
      variables
    });
  };

  try {
    return await mutationAPI().then(res => {
      return res;
    });
  } catch (e) {// console.log('e', e)
  }
};

exports.upsertUnique = upsertUnique;

const deleteUnique = async variables => {
  const mutationAPI = () => {
    const mutation = (0, _graphqlTag.default)(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n        mutation($id: ID, $ids: [ID]) {\n  delete_unique(\n    input: {\n      id: $id,\n      ids: $ids,\n    }\n  )\n}\n"])));
    return _graphqlClient.graphqlClient.mutate({
      mutation,
      variables
    });
  };

  try {
    return await mutationAPI().then(res => {
      return res;
    });
  } catch (e) {// console.log('e', e)
  }
};

exports.deleteUnique = deleteUnique;