"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ChatAntd = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

require("core-js/modules/web.dom.iterable.js");

var _react = _interopRequireWildcard(require("react"));

var _moment = _interopRequireDefault(require("moment"));

require("moment-timezone");

var _graphqlComment = require("./Graphql/graphqlComment");

var _InputComment = _interopRequireDefault(require("./Components/InputComment"));

require("../../styles/antd/antd-output.css");

require("../../styles/tailwind/tailwind-output.css");

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _pusherCodeby = require("../../configs/pusherCodeby");

var _PeopleCalling = _interopRequireDefault(require("./Components/PeopleCalling"));

var _graphqlChat = require("./Graphql/graphqlChat");

var _graphqlChatRoom = require("./Graphql/graphqlChatRoom");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const querystring = require('query-string');

const flatten = require('flat');

const ChatAntd = props => {
  var _lComment$data;

  _moment.default.tz.setDefault('UTC');

  const {
    app_id,
    unique,
    onChange,
    people,
    other,
    height,
    width,
    onClose
  } = props;
  const [lComment, setLComment] = (0, _react.useState)({});
  const [lChatRT, setLChatRT] = (0, _react.useState)([]);
  const [videoChat, setVideoChat] = (0, _react.useState)(null);
  const roomId = "".concat(app_id, "-").concat(unique.special_id); // console.log('ChatAntd roomId', roomId)

  (0, _react.useEffect)(() => {
    if (lComment.data && onChange) onChange(lComment);
  }, [lComment]);
  (0, _react.useEffect)(() => {
    (async () => {
      var _res$data;

      (0, _graphqlChatRoom.upsertChatRoom)({
        app_id,
        unique,
        people_list: [people, other]
      });
      const res = await (0, _graphqlComment.listComment)({
        app_id,
        unique
      });
      setLComment(res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : _res$data.list_comment);
    })();
  }, []);

  const updateReadFn = () => {
    let read_comment_id;

    try {
      read_comment_id = lChatRT[0] && lChatRT[0].id ? lChatRT[0].id : lComment.data && lComment.data[0] && lComment.data[0].id ? lComment.data[0].id : null;
      read_comment_id = parseInt(read_comment_id);
    } catch (e) {}

    (async () => {
      if (read_comment_id) {
        console.log('read_comment_id', read_comment_id);
        await (0, _graphqlChat.upsertChat)({
          app_id,
          people,
          unique,
          read_comment_id
        }); // pusherCodeby.room(roomId).emit('fresh_detail_chat', {data:"test"});
      }
    })();
  };

  (0, _react.useEffect)(() => {
    updateReadFn();
  }, [lComment]);
  (0, _react.useEffect)(() => {
    updateReadFn();
  }, [lChatRT]);
  (0, _react.useEffect)(() => {
    const listener = _pusherCodeby.pusherCodeby.room(roomId).onAny((event, data) => {
      console.log('event, data', event, data);

      switch (event) {
        case 'chat':
          setLChatRT([data.data, ...lChatRT]);
          break;

        case 'video_chat_cancel':
          if (data.people.special_id != people.special_id) setVideoChat(null);
          break;

        case 'video_chat':
          if (data.people.special_id != people.special_id) setVideoChat(data);
          break;
      }
    });

    return () => _pusherCodeby.pusherCodeby.offAny(listener);
  });

  const ModalRender = () => {
    const [iComment, setIComment] = (0, _react.useState)({});
    (0, _react.useEffect)(() => {
      if (iComment.data) {
        console.log('iComment', iComment);

        _pusherCodeby.pusherCodeby.room(roomId).emit('chat', iComment);

        setLChatRT([iComment.data, ...lChatRT]);
        setVideoChat(null);
      }
    }, [iComment]);

    const missedVideoCall = async () => {
      const res = await (0, _graphqlComment.upsertComment)({
        unique,
        people,
        app_id,
        content: "Video chat missed",
        type: "video_chat"
      });
      setIComment({
        isLoading: true,
        data: res.data.upsert_comment
      });
    };

    return /*#__PURE__*/_react.default.createElement(_antd.Modal, {
      visible: true,
      className: "modal_video_chat"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "h-96 relative"
    }, /*#__PURE__*/_react.default.createElement(_PeopleCalling.default, {
      people: videoChat.people
    }), /*#__PURE__*/_react.default.createElement("div", {
      className: "absolute absolute-x bottom-0 mb-3"
    }, /*#__PURE__*/_react.default.createElement(_antd.Space, {
      size: "large"
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      size: "large",
      icon: /*#__PURE__*/_react.default.createElement(_icons.CheckOutlined, null),
      onClick: () => {
        setVideoChat(null);
        window.open(videoChat.url + '&join=1', 'windowName', "height=600,width=800");
      }
    }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
      size: "large",
      icon: /*#__PURE__*/_react.default.createElement(_icons.CloseOutlined, null),
      onClick: () => missedVideoCall()
    })))));
  };

  return /*#__PURE__*/_react.default.createElement("section", {
    className: "text-left space-y-2"
  }, videoChat && /*#__PURE__*/_react.default.createElement(ModalRender, null), /*#__PURE__*/_react.default.createElement("main", {
    style: {
      height,
      width
    },
    className: "flex flex-col items-center justify-center"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "flex flex-col flex-grow w-full bg-white overflow-hidden "
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "flex justify-between border-b pb-2"
  }, /*#__PURE__*/_react.default.createElement("figure", {
    className: "flex items-center"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "w-8"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "pb-1x1 relative rounded-full overflow-hidden bg-gray-300"
  }, /*#__PURE__*/_react.default.createElement("img", {
    alt: "",
    src: other.avatar,
    className: "absolute h-full w-full object-cover"
  }))), /*#__PURE__*/_react.default.createElement("figcaption", {
    className: "ml-2"
  }, other.name)), /*#__PURE__*/_react.default.createElement(_antd.Space, null, unique.video_chat_url && /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.VideoCameraOutlined, null),
    onClick: () => {
      const queryString = querystring.stringify(flatten(props));
      window.open("".concat(unique.video_chat_url, "?").concat(queryString), 'windowName', "height=600,width=800");
    }
  }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.CloseOutlined, null),
    onClick: () => {
      if (onClose) onClose(true);
    }
  }))), /*#__PURE__*/_react.default.createElement("ul", {
    className: "flex flex-col flex-grow flex-col-reverse h-0 overflow-auto pb-2"
  }, lChatRT.concat((_lComment$data = lComment === null || lComment === void 0 ? void 0 : lComment.data) !== null && _lComment$data !== void 0 ? _lComment$data : []).map(item => {
    var _item$people, _item$people4, _item$people5;

    if ((people === null || people === void 0 ? void 0 : people.special_id) == ((_item$people = item.people) === null || _item$people === void 0 ? void 0 : _item$people.special_id)) {
      var _item$people2, _item$people3;

      return /*#__PURE__*/_react.default.createElement("li", {
        className: "flex w-full mt-2 space-x-3 max-w-xs ml-auto justify-end"
      }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", {
        className: "bg-blue-600 text-white p-3 rounded-l-lg rounded-br-lg"
      }, /*#__PURE__*/_react.default.createElement("p", {
        className: "text-sm"
      }, item.content)), /*#__PURE__*/_react.default.createElement("span", {
        className: "text-xs text-gray-500 leading-none"
      }, (0, _moment.default)(item.created_at).fromNow())), /*#__PURE__*/_react.default.createElement("div", {
        className: "flex-shrink-0 w-10 h-10 rounded-full overflow-hidden"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "pb-1x1 relative rounded-sm overflow-hidden bg-gray-300"
      }, /*#__PURE__*/_react.default.createElement("img", {
        alt: (_item$people2 = item.people) === null || _item$people2 === void 0 ? void 0 : _item$people2.name,
        src: (_item$people3 = item.people) === null || _item$people3 === void 0 ? void 0 : _item$people3.avatar,
        className: "absolute h-full w-full object-cover"
      }))));
    }

    return /*#__PURE__*/_react.default.createElement("li", {
      className: "flex w-full mt-2 space-x-3 max-w-xs"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "flex-shrink-0 w-10 h-10 rounded-full overflow-hidden"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "pb-1x1 relative rounded-sm overflow-hidden bg-gray-300"
    }, /*#__PURE__*/_react.default.createElement("img", {
      alt: (_item$people4 = item.people) === null || _item$people4 === void 0 ? void 0 : _item$people4.name,
      src: (_item$people5 = item.people) === null || _item$people5 === void 0 ? void 0 : _item$people5.avatar,
      className: "absolute h-full w-full object-cover"
    }))), /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", {
      className: "bg-gray-300 p-3 rounded-r-lg rounded-bl-lg"
    }, /*#__PURE__*/_react.default.createElement("p", {
      className: "text-sm"
    }, item.content)), /*#__PURE__*/_react.default.createElement("span", {
      className: "text-xs text-gray-500 leading-none"
    }, (0, _moment.default)(item.created_at).fromNow())));
  })), /*#__PURE__*/_react.default.createElement(_InputComment.default, (0, _extends2.default)({}, props, {
    onChange: values => {
      setLChatRT([values.data, ...lChatRT]);
    }
  })))));
};

exports.ChatAntd = ChatAntd;