"use strict";

require("core-js/modules/es6.symbol.js");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("core-js/modules/web.dom.iterable.js");

var _react = _interopRequireWildcard(require("react"));

var _graphqlLike = require("../Graphql/graphqlLike");

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _moment = _interopRequireDefault(require("moment"));

var _InputComment = _interopRequireDefault(require("./InputComment"));

var _graphqlComment = require("../Graphql/graphqlComment");

var _graphqlSubComment = require("../Graphql/graphqlSubComment");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const ItemComment = props => {
  var _icData$people, _icData$people2, _icData$comment;

  const {
    data,
    onChange: _onChange,
    isSub
  } = props;
  const [showInput, setShowInput] = (0, _react.useState)(false);
  const [sLike, setSLike] = (0, _react.useState)({});
  const [icData, setIcData] = (0, _react.useState)({});
  (0, _react.useEffect)(() => {
    setIcData(data);
  }, [data]);
  const [isEdit, setIsEdit] = (0, _react.useState)();

  const sendLike = async () => {
    var _res$data;

    setSLike({
      isLoading: true
    });
    let variables = {
      "id": null,
      "app_id": "1",
      "likeable_type": "App\\Models\\Comment",
      "likeable_id": icData.id,
      "is_like": true,
      "people": props.people
    };

    if (isSub) {
      variables.likeable_type = "App\\Models\\SubComment";
    }

    const res = await (0, _graphqlLike.upsertLike)(variables);
    setSLike({
      data: res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : _res$data.upsert_like
    });
  };

  const DropdownAct = _ref => {
    let {
      onAct
    } = _ref;

    const menu = /*#__PURE__*/_react.default.createElement(_antd.Menu, null, /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, null, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      icon: /*#__PURE__*/_react.default.createElement(_icons.EditOutlined, null),
      block: true,
      type: "link",
      className: "text-left px-0",
      onClick: () => onAct('edit')
    }, "Edit")), /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, null, /*#__PURE__*/_react.default.createElement(_antd.Popconfirm, {
      title: "Delete comment: ".concat(icData.content),
      onConfirm: () => onAct('delete'),
      okText: "Yes",
      cancelText: "No"
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      danger: true,
      icon: /*#__PURE__*/_react.default.createElement(_icons.DeleteOutlined, null),
      block: true,
      type: "link",
      className: "text-left px-0"
    }, "Delete"))));

    return /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
      overlay: menu,
      placement: "bottomRight",
      arrow: true,
      className: "absolute top-0 right-0 group-hover:block hidden "
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      icon: /*#__PURE__*/_react.default.createElement(_icons.MoreOutlined, null)
    }));
  };

  return /*#__PURE__*/_react.default.createElement("section", {
    className: "group"
  }, /*#__PURE__*/_react.default.createElement("figure", {
    className: "float-left"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "w-12"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "pb-1x1 relative rounded-full overflow-hidden bg-gray-300"
  }, /*#__PURE__*/_react.default.createElement("img", {
    src: (_icData$people = icData.people) === null || _icData$people === void 0 ? void 0 : _icData$people.avatar,
    className: "absolute h-full w-full object-cover"
  })))), /*#__PURE__*/_react.default.createElement("div", {
    className: "pl-14 relative"
  }, !isEdit && /*#__PURE__*/_react.default.createElement(DropdownAct, {
    onAct: async act => {
      if (act == 'delete' && isSub) {
        await (0, _graphqlSubComment.deleteSubComment)({
          id: icData.id
        });

        _onChange({
          act: 'delete',
          data: icData
        });

        return;
      }

      if (act == 'delete') {
        await (0, _graphqlComment.deleteComment)({
          id: icData.id
        });

        _onChange({
          act: 'delete',
          data: icData
        });

        return;
      }

      if (act == 'edit') {
        setIsEdit(true);
      }
    }
  }), /*#__PURE__*/_react.default.createElement("b", null, (_icData$people2 = icData.people) === null || _icData$people2 === void 0 ? void 0 : _icData$people2.name), isEdit && /*#__PURE__*/_react.default.createElement(_InputComment.default, (0, _extends2.default)({}, props, {
    comment_id: icData === null || icData === void 0 ? void 0 : (_icData$comment = icData.comment) === null || _icData$comment === void 0 ? void 0 : _icData$comment.id,
    iData: icData,
    onClose: () => setIsEdit(false),
    onChange: values => {
      setIsEdit(false);
      setIcData(_objectSpread(_objectSpread({}, icData), {}, {
        content: values.data.content
      }));
    }
  })), !isEdit && /*#__PURE__*/_react.default.createElement("span", {
    className: "ml-2 "
  }, icData.content), /*#__PURE__*/_react.default.createElement("div", {
    className: "flex justify-between w-full"
  }, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    size: "large"
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "p-0",
    type: "link",
    onClick: async () => sendLike(),
    loading: sLike.isLoading
  }, /*#__PURE__*/_react.default.createElement("span", null, icData.total_like + (sLike.data ? 1 : 0)), /*#__PURE__*/_react.default.createElement(_icons.LikeOutlined, null)), !isSub && /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "p-0",
    type: "link",
    danger: showInput,
    onClick: () => setShowInput(!showInput)
  }, "Tr\u1EA3 l\u1EDDi"), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    className: "p-0",
    type: "link"
  }, (0, _moment.default)(icData.created_at).fromNow()))), showInput && /*#__PURE__*/_react.default.createElement(_InputComment.default, (0, _extends2.default)({}, props, {
    comment_id: icData === null || icData === void 0 ? void 0 : icData.id,
    onChange: values => {
      _onChange(_objectSpread(_objectSpread({}, values), {}, {
        act: 'add'
      }));

      if (values.data) setShowInput(false); // console.log('InputComment values', values)
    }
  }))));
};

var _default = ItemComment;
exports.default = _default;