"use strict";

require("core-js/modules/es6.symbol.js");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CommentAntd = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("core-js/modules/web.dom.iterable.js");

var _antd = require("antd");

var _react = _interopRequireWildcard(require("react"));

var _moment = _interopRequireDefault(require("moment"));

require("moment-timezone");

var _graphqlComment = require("./Graphql/graphqlComment");

var _ParentComment = _interopRequireDefault(require("./Components/ParentComment"));

var _InputComment = _interopRequireDefault(require("./Components/InputComment"));

require("../../styles/antd/antd-output.css");

require("../../styles/tailwind/tailwind-output.css");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const CommentAntd = props => {
  var _lComment$pageInfo$to, _lComment$pageInfo, _lComment$data;

  _moment.default.tz.setDefault('UTC');

  const {
    app_id,
    unique,
    onChange
  } = props;
  const [lComment, setLComment] = (0, _react.useState)({});
  (0, _react.useEffect)(() => {
    // console.log('lComment', lComment.data)
    if (lComment.data && onChange) onChange(lComment);
  }, [lComment]);

  const getLComment = async () => {
    var _res$data;

    const res = await (0, _graphqlComment.listComment)({
      app_id,
      unique
    });
    setLComment(res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : _res$data.list_comment);
  };

  (0, _react.useEffect)(() => {
    (async () => getLComment())();
  }, []);
  return /*#__PURE__*/_react.default.createElement("section", {
    className: "text-left space-y-2 "
  }, /*#__PURE__*/_react.default.createElement("h4", {
    className: "font-semibold"
  }, "Comments (", (_lComment$pageInfo$to = lComment === null || lComment === void 0 ? void 0 : (_lComment$pageInfo = lComment.pageInfo) === null || _lComment$pageInfo === void 0 ? void 0 : _lComment$pageInfo.total_item) !== null && _lComment$pageInfo$to !== void 0 ? _lComment$pageInfo$to : '-', ")"), /*#__PURE__*/_react.default.createElement(_InputComment.default, (0, _extends2.default)({}, props, {
    onChange: values => {
      setLComment(_objectSpread(_objectSpread({}, lComment), {}, {
        data: [values.data, ...lComment.data],
        pageInfo: _objectSpread(_objectSpread({}, lComment.pageInfo), {}, {
          total_item: lComment.pageInfo.total_item + 1
        })
      }));
    }
  })), ((_lComment$data = lComment === null || lComment === void 0 ? void 0 : lComment.data) !== null && _lComment$data !== void 0 ? _lComment$data : []).length != 0 && /*#__PURE__*/_react.default.createElement(_antd.List, {
    itemLayout: "vertical",
    dataSource: lComment === null || lComment === void 0 ? void 0 : lComment.data,
    renderItem: item => /*#__PURE__*/_react.default.createElement(_antd.List.Item, {
      key: item.id
    }, /*#__PURE__*/_react.default.createElement(_ParentComment.default, (0, _extends2.default)({}, props, {
      cData: item,
      onChange: values => {
        // console.log('ParentComment values', values)
        if (values.act == 'delete') {
          var _lComment$data2;

          const dlComment = ((_lComment$data2 = lComment === null || lComment === void 0 ? void 0 : lComment.data) !== null && _lComment$data2 !== void 0 ? _lComment$data2 : []).filter(item => item.id != values.data.id);

          const nlComment = _objectSpread(_objectSpread({}, lComment), {}, {
            data: dlComment,
            pageInfo: _objectSpread(_objectSpread({}, lComment.pageInfo), {}, {
              total_item: lComment.pageInfo.total_item - 1
            })
          });

          setLComment(nlComment);
        }
      }
    })))
  }));
};

exports.CommentAntd = CommentAntd;